// Code generated by go-swagger; DO NOT EDIT.

package metrics

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewWorkflowMetricsSuccessfulParams creates a new WorkflowMetricsSuccessfulParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWorkflowMetricsSuccessfulParams() *WorkflowMetricsSuccessfulParams {
	return &WorkflowMetricsSuccessfulParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWorkflowMetricsSuccessfulParamsWithTimeout creates a new WorkflowMetricsSuccessfulParams object
// with the ability to set a timeout on a request.
func NewWorkflowMetricsSuccessfulParamsWithTimeout(timeout time.Duration) *WorkflowMetricsSuccessfulParams {
	return &WorkflowMetricsSuccessfulParams{
		timeout: timeout,
	}
}

// NewWorkflowMetricsSuccessfulParamsWithContext creates a new WorkflowMetricsSuccessfulParams object
// with the ability to set a context for a request.
func NewWorkflowMetricsSuccessfulParamsWithContext(ctx context.Context) *WorkflowMetricsSuccessfulParams {
	return &WorkflowMetricsSuccessfulParams{
		Context: ctx,
	}
}

// NewWorkflowMetricsSuccessfulParamsWithHTTPClient creates a new WorkflowMetricsSuccessfulParams object
// with the ability to set a custom HTTPClient for a request.
func NewWorkflowMetricsSuccessfulParamsWithHTTPClient(client *http.Client) *WorkflowMetricsSuccessfulParams {
	return &WorkflowMetricsSuccessfulParams{
		HTTPClient: client,
	}
}

/* WorkflowMetricsSuccessfulParams contains all the parameters to send to the API endpoint
   for the workflow metrics successful operation.

   Typically these are written to a http.Request.
*/
type WorkflowMetricsSuccessfulParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* Workflow.

	   path to target workflow
	*/
	Workflow string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the workflow metrics successful params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WorkflowMetricsSuccessfulParams) WithDefaults() *WorkflowMetricsSuccessfulParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the workflow metrics successful params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WorkflowMetricsSuccessfulParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the workflow metrics successful params
func (o *WorkflowMetricsSuccessfulParams) WithTimeout(timeout time.Duration) *WorkflowMetricsSuccessfulParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the workflow metrics successful params
func (o *WorkflowMetricsSuccessfulParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the workflow metrics successful params
func (o *WorkflowMetricsSuccessfulParams) WithContext(ctx context.Context) *WorkflowMetricsSuccessfulParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the workflow metrics successful params
func (o *WorkflowMetricsSuccessfulParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the workflow metrics successful params
func (o *WorkflowMetricsSuccessfulParams) WithHTTPClient(client *http.Client) *WorkflowMetricsSuccessfulParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the workflow metrics successful params
func (o *WorkflowMetricsSuccessfulParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the workflow metrics successful params
func (o *WorkflowMetricsSuccessfulParams) WithNamespace(namespace string) *WorkflowMetricsSuccessfulParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the workflow metrics successful params
func (o *WorkflowMetricsSuccessfulParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithWorkflow adds the workflow to the workflow metrics successful params
func (o *WorkflowMetricsSuccessfulParams) WithWorkflow(workflow string) *WorkflowMetricsSuccessfulParams {
	o.SetWorkflow(workflow)
	return o
}

// SetWorkflow adds the workflow to the workflow metrics successful params
func (o *WorkflowMetricsSuccessfulParams) SetWorkflow(workflow string) {
	o.Workflow = workflow
}

// WriteToRequest writes these params to a swagger request
func (o *WorkflowMetricsSuccessfulParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// path param workflow
	if err := r.SetPathParam("workflow", o.Workflow); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
