// Code generated by go-swagger; DO NOT EDIT.

package namespace_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewListNamespaceServiceRevisionPodsParams creates a new ListNamespaceServiceRevisionPodsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListNamespaceServiceRevisionPodsParams() *ListNamespaceServiceRevisionPodsParams {
	return &ListNamespaceServiceRevisionPodsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListNamespaceServiceRevisionPodsParamsWithTimeout creates a new ListNamespaceServiceRevisionPodsParams object
// with the ability to set a timeout on a request.
func NewListNamespaceServiceRevisionPodsParamsWithTimeout(timeout time.Duration) *ListNamespaceServiceRevisionPodsParams {
	return &ListNamespaceServiceRevisionPodsParams{
		timeout: timeout,
	}
}

// NewListNamespaceServiceRevisionPodsParamsWithContext creates a new ListNamespaceServiceRevisionPodsParams object
// with the ability to set a context for a request.
func NewListNamespaceServiceRevisionPodsParamsWithContext(ctx context.Context) *ListNamespaceServiceRevisionPodsParams {
	return &ListNamespaceServiceRevisionPodsParams{
		Context: ctx,
	}
}

// NewListNamespaceServiceRevisionPodsParamsWithHTTPClient creates a new ListNamespaceServiceRevisionPodsParams object
// with the ability to set a custom HTTPClient for a request.
func NewListNamespaceServiceRevisionPodsParamsWithHTTPClient(client *http.Client) *ListNamespaceServiceRevisionPodsParams {
	return &ListNamespaceServiceRevisionPodsParams{
		HTTPClient: client,
	}
}

/* ListNamespaceServiceRevisionPodsParams contains all the parameters to send to the API endpoint
   for the list namespace service revision pods operation.

   Typically these are written to a http.Request.
*/
type ListNamespaceServiceRevisionPodsParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* RevisionGeneration.

	   target revision generation
	*/
	RevisionGeneration string

	/* ServiceName.

	   target service name
	*/
	ServiceName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list namespace service revision pods params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListNamespaceServiceRevisionPodsParams) WithDefaults() *ListNamespaceServiceRevisionPodsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list namespace service revision pods params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListNamespaceServiceRevisionPodsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the list namespace service revision pods params
func (o *ListNamespaceServiceRevisionPodsParams) WithTimeout(timeout time.Duration) *ListNamespaceServiceRevisionPodsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list namespace service revision pods params
func (o *ListNamespaceServiceRevisionPodsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list namespace service revision pods params
func (o *ListNamespaceServiceRevisionPodsParams) WithContext(ctx context.Context) *ListNamespaceServiceRevisionPodsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list namespace service revision pods params
func (o *ListNamespaceServiceRevisionPodsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list namespace service revision pods params
func (o *ListNamespaceServiceRevisionPodsParams) WithHTTPClient(client *http.Client) *ListNamespaceServiceRevisionPodsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list namespace service revision pods params
func (o *ListNamespaceServiceRevisionPodsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the list namespace service revision pods params
func (o *ListNamespaceServiceRevisionPodsParams) WithNamespace(namespace string) *ListNamespaceServiceRevisionPodsParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the list namespace service revision pods params
func (o *ListNamespaceServiceRevisionPodsParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithRevisionGeneration adds the revisionGeneration to the list namespace service revision pods params
func (o *ListNamespaceServiceRevisionPodsParams) WithRevisionGeneration(revisionGeneration string) *ListNamespaceServiceRevisionPodsParams {
	o.SetRevisionGeneration(revisionGeneration)
	return o
}

// SetRevisionGeneration adds the revisionGeneration to the list namespace service revision pods params
func (o *ListNamespaceServiceRevisionPodsParams) SetRevisionGeneration(revisionGeneration string) {
	o.RevisionGeneration = revisionGeneration
}

// WithServiceName adds the serviceName to the list namespace service revision pods params
func (o *ListNamespaceServiceRevisionPodsParams) WithServiceName(serviceName string) *ListNamespaceServiceRevisionPodsParams {
	o.SetServiceName(serviceName)
	return o
}

// SetServiceName adds the serviceName to the list namespace service revision pods params
func (o *ListNamespaceServiceRevisionPodsParams) SetServiceName(serviceName string) {
	o.ServiceName = serviceName
}

// WriteToRequest writes these params to a swagger request
func (o *ListNamespaceServiceRevisionPodsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// path param revisionGeneration
	if err := r.SetPathParam("revisionGeneration", o.RevisionGeneration); err != nil {
		return err
	}

	// path param serviceName
	if err := r.SetPathParam("serviceName", o.ServiceName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
